colorTools = {}
--self.musicColor = colorTools:RGBglow(dt,2,0,255,self.musicColor,false)
function colorTools:RGBglow(dt, r, min, max, cur, brightening)
	--cause a color to glow or darken, but only if it is R, G, or B
	r = r or 1
	min = min or 0
	max = max or 255
	if brightening then
		cur = cur + (dt * max) / r
		if cur >= max then
			cur = max
		end
	else
		cur = cur - (dt * max) / r
		if cur <= min then
			cur = min
		end
	end
	
	return cur
end


function colorTools:HSL(h, s, l, a)
   if s<=0 then return l,l,l,a end
   h, s, l = h/360*6, s/100, l/100
   --Edited the H, S and L bounds to be 360, 100, 100. H's was 256 before, so that 255 was just a bit before pure red (which would equal 0),
   --now it's 360 though, so HSL(360, 100, 50) actually equals HSL(0, 100, 50).
   local c = (1-math.abs(2*l-1))*s
   local x = (1-math.abs(h%2-1))*c
   local m,r,g,b = (l-.5*c), 0,0,0
   if h < 1     then r,g,b = c,x,0
   elseif h < 2 then r,g,b = x,c,0
   elseif h < 3 then r,g,b = 0,c,x
   elseif h < 4 then r,g,b = 0,x,c
   elseif h < 5 then r,g,b = x,0,c
   else              r,g,b = c,0,x
   end return (r+m)*255,(g+m)*255,(b+m)*255,a
end

return colorTools