--note: finish fadeout function
--correctly write findUniqueIndex()

audio = {}
audio.sources = {}
function audio:loadProfile(p) --a:loadProfile(o)
	if p.index and (p.sfx or p.bgm) then
		audio.sources[p.index] = {} --index is a string
		local list = {}
		local filelists = {}
		if p.bgm then filelists[#filelists+1] = "bgm" end
		if p.sfx then filelists[#filelists+1] = "sfx" end
		for i=1, #filelists do
			local ind = filelists[i]
			if p[ind].addRandomizer and not p[ind].rand then
				p[ind].rand = self:initializeRandomizer()
			end
			
			for i,v in pairs(p[ind]) do
				if (type(v) == "table") and v.f then
					local s = "assets/"..ind.."/"..v.f
					local a = {}
					a.src = love.audio.newSource(s, v.t)
					local vol = v.v or globals.volume[ind]
					a.src:setVolume(vol)
					function a:play(seek, loop, vol) --state.sfx.attack.play(13, false)
						loop = loop or false
						if self.isLooping ~= loop then --avoid re-evaluating loop every time it's asked for
							self.src:setLooping(loop)
							self.isLooping = loop
						end
						if seek and seek > 0 then
							self.src:seek(seek)
						else
							self.src:play()
						end			
					end
					function a:stop()
						self.src:stop()				
					end
					function a:pause()
						self.src:pause()
					end
					function a:resume()
						self.src:resume()
					end
					function a:changeVolume(v)
						self.src:setVolume(v)
					end
					function a:setFade(t)
						if a.v ~= 0 then --avoid divide by 0 error
							t = t or 1 --fade over 1 second if no other option set
							local currentVolume = a.v
							local slice = 1/currentVolume
							
							local fade = {}
								fade.t = t
								fade.slice = slice
								fade.src = a.src
								fade.fade = true
								fade.v = a.v
							local index = math.random(0,1000)-- findUniqueIndex(audio.fadeList)
							audio.fadeList[index] = fade
							--v = v - dt/t * slice
						end
					end
					function a:stopFade()
						
					end
					a.v = vol
					a.f = v.f
					a.t = v.t
					a.title = v.title
					a.link = v.link
					a.download = v.download
					a.author = v.author
					a.isLooping = false
					p[ind][i] = a --add the sound struct, including source, back to the original table
					--print(p.audio[i].src)
					--so it can be called from the table itself
					list[#list + 1] = a
					if p[ind].addRandomizer then p[ind].rand:addAudio(p[ind][i]) end
				end
			end
		end
		audio.sources[p.index] = list
	end
end

function audio:unloadProfile(i) --a:unloadProfile(o.index)
	audio.sources[i] = nil
end

audio.fadeList = {}

function audio:update(dt)
	self:updateFades(dt)
end

function audio:updateFades(dt)
	for i,v in pairs(self.fadeList) do
		if v.v <= 0 then
			v.src:stop()
			self.fadeList[i] = nil
		else
			if v.fade then
				v.v = v.v - dt--/v.t * v.slice
				v.src:setVolume(v.v)
			end			
		end
	end
end


function audio:initializeRandomizer()
	local t = {}
	t.list = {}
	t.current = 0
	t.delayBetweenTracks = 0.7
	t.delay = 0
	t.isPaused = false
	function t:addAudio(a)
		self.list[#self.list+1] = a
	end
	function t:start()
		local r = math.random(1, #self.list)
		
		self.list[r]:play()	
		self.current = r		
	end
	function t:update(dt)
		if not self.isPaused then --don't run logic at all while music is paused
			if self.list[self.current].src:isPlaying() then
				--do nothing
			elseif self.delay < self.delayBetweenTracks then
				--print("delaying")
				self.delay = self.delay + dt
			else
				--print("switching")
				--in the future, we will play a "record switch" sound
				self.delay = 0
				local r = self.current
				while r == self.current do
					r = math.random(1, #self.list)
				end
				self.list[r]:play()
				self.current = r
			end
		end
	end
	function t:pause()
		if not self.isPaused then
			self.list[r]:pause()
			self.isPaused = true
		end
	end
	function t:resume()
		if self.isPaused then
			self.list[r]:resume()
			self.isPaused = false
		end
	end
	return t
end



return audio



--[[theoretical o.audio looks like:

o.audio = {
	index = "opening"
	attack = {f = "file.ogg", t = "static"}
--]]