--purpose:
--each entity can only take damage once per update cycle
--when two entities of opposing hit-and-hurtboxes touch, this
--ensures that each damaged entity is put into a 
--'going to be damaged' state, and then that is resolved
--in this list, at the end of all updates

--this list resolves damage for every entity on it,
--then removes that entity's reference from its space
--and resets its size for next update

--this list shouldn't ever reach a great number
--but its use will insure that damage cannot stack 
--unwantedly

damageList = {
			number = 1
			}
			
function damageList:resolve()
	for i=1, self.number do
		if self[i] then
			self[i]:resolveDamage()
			self[i] = nil
		end
	end
	
	self.number = 1
end

return damageList