local effectPrimitives = require 'engine.gameplay.effects.effects'
local eP = effectPrimitives
effects = {}

effects.list = {
	size = 1,
	garbage = 0,
	compactSize = 100, --if the list reaches this size, compact it by removing nils
}

--syntax:
--effects:new(t, loc, sub) --rewrite all calls to use strings
function effects:new(t, loc, sub)
	local q = eP[t]:initialize(loc, sub)
	local r
	if q.chance then
		if q.chance > math.random(0,100) then
			r = true
		else
			r = false
		end
	else
		r = true
	end
	if r then
		q.queueSpot = effects.list.size
		effects.list[q.queueSpot] = q	
		effects.list.size = effects.list.size + 1
	end
end

function effects:update(dt)
	for i=1, self.list.size do
		if self.list[i] then self.list[i]:update(dt, self.list) end
	end
	
	if self.list.garbage >= self.list.compactSize then
		self.list = self:compact()
	end
end

function effects:draw()
	for i=1, self.list.size do
		if self.list[i] then self.list[i]:draw() end
	end

end

function effects:compact()
	local ot = self.list
	local nt = {size = 1, garbage = 0, compactSize = ot.compactSize}
	for i=1, ot.size do
		if ot[i] then
			nt[nt.size] = ot[i]
			nt[nt.size].queueSpot = i
			nt.size = nt.size + 1
		end
	end	
	
	return nt
end

return effects