require 'engine.gameplay.entities.squareo'

enemyRNG = {enemyCount = 0, enemyStart = 0}
enemyList = {}
enemyListLen = 1

function enemyRNG:initialize(m, mod, audio)
	if mod == nil then 
		mod = {}
		mod.enemies = 0
	end
	--print("enemy modifier for current instant == "..tostring(mod.enemies))
	local enemyAmount = 10 + mod.enemies
	local enemyTypes = {e_red,e_blue,e_orange,e_yellow} --these are from squareo
	
	
	for i=1, enemyAmount do
		local check = true
		while check do
			local xr = math.random(2, m.w - 1)
			local yr = math.random(2, m.h - 1)
			if m[yr][xr] == 0 then
				local t = math.random(1,4)
				self:newEnemy(xr*m.block.w,yr*m.block.h,enemyTypes[t], mod, audio)
				--map[yr][xr] = 1
				check = false
				self.enemyCount = self.enemyCount + 1
			end
		end
	end	
	self.enemyStart = self.enemyCount
end

function enemyRNG:clear()
	for i=1, self.enemyCount do
		if enemyList[i].alive then enemyList[i]:kill() end
		enemyList[i] = nil
	end
	
	self.enemyCount = 0
	enemyListLen = 1
end


function enemyRNG: newEnemy (x,y,t, mod, audio)
	local p = t:initialize(x,y, mod)
	audio:loadProfile(p)
	enemyList[enemyListLen] = p	
	enemyListLen = enemyListLen + 1
	world:add(p,p.x,p.y,p.w,p.h)
end

function enemyRNG:update(dt)
	for i=1, enemyListLen-1 do
		if enemyList[i] then enemyList[i]:update(dt) end
	end
	
end

return enemyRNG