hud = {
	hp = {string = 'Health: ', amt = 0, x = 100, y = 100},
	enemies = {string = 'Enemies: ', amt = 0, x = 300, y = 100},
	victories = {string = 'Victories: ', amt = 0, x = 500, y = 200},
	losses = {string = 'Losses: ', amt = 0, x = 500, y = 250},
	gameTime = {string = 'Current Game Time: ', h_amt = 0, m_amt = 0, s_amt = 0, x = 200, y = 150},
	
	currentMusic = {
		title = " ",
		f = " ",
		download = " ",
		author = " ",
	},
	musicDelay = 6,
	musicDispTime = 0,
	musicColor = 0,
	musicBrightening = true,
	musicX = 0,
	musicY = 0,
	musicXMod = 325,
	musicYMod = 125,
}

function hud:initialize(m, c, p, e, play)
	hud.hp.amt = p.hp
	hud.enemies.amt = e.enemyCount
	self.musicX = lg.getWidth() - self.musicXMod
	self.musicY = lg.getHeight() - self.musicYMod
end

function hud:update(dt, m, c, p, e, play)
	hud.hp.amt = p.hp
	hud.enemies.amt = e.enemyCount
	hud.victories.amt = play.wins
	hud.losses.amt = play.losses
	self.musicX = lg.getWidth() - self.musicXMod
	self.musicY = lg.getHeight() - self.musicYMod
	
	local sg = self.gameTime
	sg.amt = convertToTimeNotation(play.gameTime)
	
	local bgm = play.bgm.rand.list[play.bgm.rand.current]
	if self.currentMusic.title ~= bgm.title then
		self.currentMusic = {
		title = bgm.title,
		f = bgm.f,
		download = bgm.download,
		author = bgm.author,
		}
		self.musicDispTime = 0
		self.musicDisplaying = true
	end
	
	if self.musicDispTime < self.musicDelay and self.musicDisplaying then
		self.musicColor = colorTools:RGBglow(dt, 2, 0, 255, self.musicColor, true)
		self.musicDispTime = self.musicDispTime + dt
	elseif self.musicColor > 0 then
		self.musicColor = colorTools:RGBglow(dt,2,0,255,self.musicColor,false)
	else
		self.musicDisplaying = false
	end
end

--self.color[2] = colorTools:RGBglow(dt, self.glowRate, 70,100 , self.color[2], self.brightening)

function hud:draw()
	love.graphics.setFont(hudfont)
	love.graphics.setColor(colorConstants.red,255)
	love.graphics.print(hud.enemies.string..tostring(hud.enemies.amt),love.graphics.getWidth()/3 + 300,hud.hp.y)
	love.graphics.setColor(colorConstants.yellow,255)
	love.graphics.print(hud.hp.string..tostring(hud.hp.amt),love.graphics.getWidth()/3,hud.hp.y)
	love.graphics.setColor(colorConstants.bright_sea_green,255)
	love.graphics.print(hud.victories.string..tostring(hud.victories.amt),hud.victories.x, hud.victories.y)
	love.graphics.setColor(colorConstants.purpley_grey,255)
	love.graphics.print(hud.losses.string..tostring(hud.losses.amt),hud.losses.x, hud.losses.y)
	love.graphics.setColor(colorConstants.ice_blue,255)
	love.graphics.print(hud.gameTime.string..hud.gameTime.amt,hud.gameTime.x,hud.gameTime.y)
	if self.musicDisplaying then
		local m = self.currentMusic
		local musicString = "Track: "..m.title.."\nAuthor: "..m.author.."\nfilename: "..m.f.."\nDownload: "..m.download
		lg.setColor(self.musicColor,self.musicColor,self.musicColor,self.musicColor)
		lg.print(musicString,self.musicX,self.musicY)
	end
end

return hud