lose = {
	stateChange = "lose",
	gameModifiers = {
		speed = 0,
		heals = 5,
	},

	disp = {string = 'Oh No!', x = 300, y = 200, newLine = 50},
	
	count = 0,
	endcount = 1.5,
	dodraw = true,
	drawKey = false,
	color = colorConstants.DOS_green,
	
	timeString = " ",
	enemyCount = " ",
	
}

function lose:load(counts)
	self.count = 0
	self.dodraw = true
	self.enemyCount = counts.enemyCount
	self.timeString = counts.timeString
	self.drawKey = false
end

function lose:update(dt)
	if self.count >= self.endcount then
		self.drawKey = true
		self:handleInput()
	else
		self.count = self.count + dt
	end		
end

function lose:draw()
	if self.dodraw then
		lg.setFont(loseFont)
		lg.setColor(self.color)
		lg.printf(self.disp.string, 0, self.disp.y, lg.getWidth(), "center")
		local string2 = "Fell to "..self.enemyCount.." foes in "..self.timeString.."\nTry Again!"
		if self.drawKey then
			string2 = string2.."\nPress Jump To Play"
		end
		lg.printf(string2, 0, self.disp.y + self.disp.newLine, lg.getWidth(), "center")
	end
end

function lose:unload()
	self.stateChange = "lose"
end

function lose:applyModifiers(mod)
	return mod
end

function lose:handleInput()
	if ic.confirm.isDown then
		self.stateChange = "new"
		self.dodraw = false
	end
end

return lose