--menuSystem module is too messy to make use of
--do not write the pause menu until the menu system is refactored

pause = {
	stateChange = "pause",
	pauseButton = true,
	pbreleased = false,
	t = 0,
	delay = 0.01, --delay between pausing and unpausing
	playDelay = 0.05, --delay between unpausing and regaining control
	unpause = false,
	doDraw = true,
	color = colorConstants.bright_yellow,
	canUnpause = false
}

function pause:load()
	self.pauseButton = true
	self.doDraw = true
	self.pbreleased = false
end

function pause:update(dt)
	if self.unpause then
		if self.t < self.playDelay then
			self.t = self.t + dt
		else
			self.stateChange = "play"
		end
	elseif self.t < self.delay then
		self.t = self.t + dt	
		if self.t > self.delay then 
			self.t = self.delay 
		end 
	else
		self.canUnpause = true
	end
	
	self:handleInput(dt)
end

function pause:draw()
	if self.doDraw then
		lg.setColor(self.color)
		lg.setFont(openingFont)
		lg.printf("PAUSED",0,lg.getHeight()/2,lg.getWidth(),"center")
	end
end

function pause:unload()
	self.stateChange = "pause"
	self.pauseButton = false
	self.t = 0
	self.unpause = false
	self.doDraw = false
	self.canUnpause = false
end

function pause:handleInput(dt)
	if not self.pbreleased then
		if not ic.pause.isDown then
			self.pbreleased = true
		end
	end
--	print(tostring(self.pbreleased).." "..tostring(ic.pause.isDown).." "..tostring(self.unpause))
	if self.pbreleased and ic.pause.isDown and not self.unpause and self.canUnpause then
		self.unpause = true
		self.t = 0
	end
end

return pause


