win = {
	stateChange = "win",
	gameModifiers = {
		speed = 0.2,
		enemies = 5,
		heals = 3,
	},

	disp = {string = 'GOOD JOB!!', x = 300, y = 200, newLine = 50},
	
	count = 0,
	endcount = 1.5,
	dodraw = true,
	drawKey = false,
	color = colorConstants.DOS_green,
	
	enemyCount = " ",
	timeString = " ",
}

function win:load(counts)
	self.count = 0
	self.dodraw = true
	self.gameModifiers.enemies = math.random(5, 10)
	self.gameModifiers.heals = self.gameModifiers.heals - 1
	
	self.enemyCount = tostring(counts.enemyCount)
	self.timeString = counts.timeString
	self.playerHP = counts.playerHP
	self.drawKey = false
	if counts.enemyCount > 1 then self.enemyString = "enemies" else self.enemyString = "enemy" end
end

function win:update(dt)
	if self.count >= self.endcount then
		self.drawKey = true
		self:handleInput()
	else
		self.count = self.count + dt
	end
end

function win:draw()
	if self.dodraw then
		lg.setFont(winFont)
		lg.setColor(self.color)
		lg.printf(self.disp.string, 0, self.disp.y, lg.getWidth(), "center")
		local string2 = "Defeated "..self.enemyCount.." "..self.enemyString.." in "..self.timeString.." with "..self.playerHP.." HP left!"
			string2 = string2.."\nNow Try It Harder!"
		if self.drawKey then
			string2 = string2.."\nPress Jump To Play"
		end
		lg.printf(string2, 0, self.disp.y + self.disp.newLine, lg.getWidth(), "center")
	end
end

function win:unload()
	self.stateChange = "win"
end

function win:applyModifiers(mod)
	local newMod = addTablesByValue(mod, self.gameModifiers)
	return newMod
end


function win:handleInput()
	if ic.confirm.isDown then
		self.stateChange = "new"
		self.dodraw = false
	end
end
return win