local ms = require 'engine.menusystem'

menu = {
	name = "menu",
}


local m = {
		base = {
		{
			x = 0,
			y = 0,
			type = "action", --can be action, field, or display
			text = "Start",
			action = function()
				stateEngine:stateSwitch("play", "new")
			end,
		},
		{
			x = 0,
			y = 0,
			type = "action",
			text = "Options",
			action = function(m)
				m:stateSwitch(m, "hs")
			end,
		},
		{
			x = 0,
			y = 0,
			type = "action",
			text = "High Scores",
			action = function(m)
				m:stateSwitch(m, "hs")
			end,
		},
		slots = 3,
		back = function()
			stateEngine:stateSwitch("open")
		end,	
	},
	opt = {
		--parse fields for column
		{
			x = 0,
			y = 0,
			type = "field", --this is a two column type
			text = "Difficulty:", --text is put in first column
			globalField = "difficulty", --variable = globals[variable]
			variable = 0, --var in second column
			action = function(m, dir)
				globals:toggleDifficulty(dir)
				m:updateFields(m)
			end,
		},
		{
			x = 0,
			y = 0,
			type = "field",
			text = "Screen Resolution:",
			globalField = "screen",
			variable = 0,
			action = function(m, dir)
				globals:toggleScreenRes(dir)
				m:updateFields(m)
			end,
		},
		{
			x = 0,
			y = 0,
			type = "field",
			text = "Boop:",
			globalField = "boop",
			variable = 0,
			action = function(m, dir)
				globals:toggleBoop(dir)
				m:updateFields(m)
			end,
		},
		{
			x = 0,
			y = 0,
			type = "field",
			text = "Placeholder:",
			globalField = "place",
			variable = 0,
			action = function(m, dir)
				globals:togglePlace(dir)
				m:updateFields(m)
			end,
		},
		slots = 4,
		back = function(m)
			m:stateSwitch(m, "base")
		end,
	},
	hs = {
		{
			x = 0,
			y = 0,
			type = "display", --this is a two column type
			text = "Coming Soon!",
			action = function()
			end,
		},
		slots = 1,
		back = function(m)
			m:stateSwitch(m, "base")
		end,
		nomarker = true, --parse for nomarker to determine if you can select
		--not coded yet.
	}
}
local menuObject = {}

function menu:load()
	ms:new(self, m)
	menuObject = ms.menuList[self.instance]
	lg.setFont(menuFont)
	menuObject.state = "base"
	ms:center(menuObject)
	ms:stateSwitch(menuObject, "base")
	menuObject.slotX, menuObject.slotY = ms:getSlotCoords(menuObject)
end

function menu:update(dt)
	interface:handleInput(dt, menuObject, "menu")
	ms:update(dt, menuObject)
end

function menu:draw()
	ms:draw(menuObject)
end



function menu:unload()
	la.stop()

end

return menu