--'opening cinematic--

opening = {
	index = "opening",
	counter = 0,
	slot = 1,
	slotend = 5,
	instance = math.random(0,1000),
	sfx = {text = {f = "text-9.wav", t = "static", v = 1.0,}, --path starts from "assets/sounds"
		space = {f = "opening/space-3.mp3", t = "static", v = 0.8,},
		scifi = {f = "scifi-computer-1.wav", t = "static", v = 0.5,},
	},
	bgm = {
	},
	--opening.bgm.click2:play()
	openRoll = {
		countdown = true,
			{
			update = function(self, dt)
				if not self.sequenceEnded then self:sequence(dt) end
				df:update(dt,"fade", 4.5)
			end,
			draw = function() 
				df:draw("Now Presenting", "fade") 
			end,
			counter = 4.5,
			seq = {
					{
						t = 0,
						a = function()
							sfx.space:play(0, true)
						end,
					},
					{
						t = 1.3,
						a = function()
						end,
					}
				},
			},
		
			{
			update = function(self, dt)
				if not self.sequenceEnded then self:sequence(dt) end
				df:update(dt,"fade", 4.5)
			end,
			draw = function()
				df:draw("A Game Crash Production", "fade") 
			end, 
			counter = 4.5,
			seq = {
					{
						t = 0.3,
						a = function()
							sfx.scifi:play(0, true)
						end,
					},
					{
						t = 1.3,
						a = function()
						end,
					}
				},
			},
		
			{
			update = function(self, dt)
				if not self.sequenceEnded then self:sequence(dt) end
				df:update(dt,"type",0.001,"JUMPY SPACE FIGHT") --not modularized well, but we can fix that later
			end,
			draw = function()
				df:draw("JUMPY SPACE FIGHT", "type") 
			end, 
			counter = 2,
			seq = {
					{
						t = 0,
						a = function()
							sfx.text:play()
						end,
					},
					{
						t = 0.65,
						a = function()
							sfx.text:stop()
						end,
					}
				},
			},
		
			{
			update = function(self, dt)
				if not self.sequenceEnded then self:sequence(dt) end
				df:update(dt,"flash",0.01)
			end,
			draw = function() 
				df:draw("*BDA BDA BDA AWESOME MOVIE CINEMATIC*", "flash") 
			end, 
			counter = 2,
			seq = {
					{
						t = 0,
						a = function()
						end,
					},
					{
						t = 0.65,
						a = function()
						end,
					}
				},
			},
		
			{
			update = function(self, dt)
				if not self.sequenceEnded then self:sequence(dt) end
				df:update(dt,"instant")
			end,
			draw = function() 
				df:draw(">particle effect goes here<", "instant") 
			end, 
			counter = 2,
			seq = {
					{
						t = 0,
						a = function()
						end,
					},
					{
						t = 1,
						a = function()
							sfx.scifi:setFade()
							sfx.space:setFade()
						end,
					}
				},
			},
	},
}

sfx = opening.sfx
bgm = opening.bgm

df = {}

function opening:load()
	lg.setFont(openingFont)
	
	for i=1, self.slotend do
		self.openRoll[i].sequence = sequence
	end	
end

function sequence (self, dt)
	if not self.seq then return end
	if not self.time then self.time = dt end
	if not self.count then self.count = 1 end
	if self.seq[self.count] then
		if self.time > self.seq[self.count].t then 
			if not self.seq[self.count].f then
				self.seq[self.count].a()
				self.seq[self.count].f = true
			end
			self.count = self.count + 1	
		end
	else
		self.sequenceEnded = true
	end
	self.time = self.time + dt
end

function df:update(dt, style, r, string) --string is only needed for type style
--fade, type, flash, instant
	if self.temp and self.temp.instance == opening.instance then
		--do stuff
		if style == "fade" then			
			if self.temp.fadein then
				self.temp.alpha = self.temp.alpha + (dt * 200) / self.temp.fadetime --reach 255 at fadetime
				if self.temp.alpha >= 200 then
					self.temp.alpha = 200
					self.temp.fadein = false
				end
			else
				self.temp.alpha = self.temp.alpha - (dt * 200) / self.temp.fadetime 
				if self.temp.alpha < 0 then
					self.temp.alpha = 0
				end
			end				
		elseif style == "type" then
			if self.temp.count < self.temp.delay then
				self.temp.count = self.temp.count + dt
			elseif self.temp.spot >= self.temp.len then
				opening.openRoll.countdown = true --reactivate countdown, end the typing
			else --delay is over, add next letter to the string			
				self.temp.count = 0
				self.temp.spot = self.temp.spot + 1
				self.temp.string = string.sub (string, 1, self.temp.spot)
			end		
		elseif style == "flash" then
			if self.temp.count < self.temp.delay then
				self.temp.count = self.temp.count + dt
			else
				self.temp.count = 0
				self.temp.display = not self.temp.display
			end		
		end
		
	else
		--establish stuff
		self.temp = {}
		self.temp.instance = opening.instance
		
		if style == "fade" then
			opening.openRoll.countdown = true
			self.temp.fadein = true
			self.temp.alpha = 0
			self.temp.time = r
			self.temp.fadetime = r/2
		elseif style == "type" then
			opening.openRoll.countdown = false
			self.temp.len = #string
			self.temp.spot = 1
			self.temp.string = string.sub (string, 1, 1)
			self.temp.delay = r
			self.temp.count = 0
		elseif style == "flash" then
			opening.openRoll.countdown = true
			self.temp.display = true
			self.temp.delay = r
			self.temp.count = 0
		end		
	end
end

function df:draw(string, style)
--fade, type, flash, instant
	local x, y = 0, lg.getHeight()/2
	local sx, sy = 1, 1
	local color = colorConstants.DOS_green
	local l = lg.getWidth()
	local a = "center"
	
	if style == "fade" then
		lg.setColor(0, self.temp.alpha, 0, 255)
		lg.printf(string, x, y, l, a, 0, sx, sy)	
	elseif style == "type" then
		lg.setColor(color, 255)
		lg.printf(self.temp.string, x, y, l, a, 0, sx, sy)	
	elseif style == "flash" then
		if self.temp.display then
			lg.setColor(color, 255)
			lg.printf(string, x, y, l, a, 0, sx, sy)
		end	
	else
		lg.setColor(color, 255)
		lg.printf(string, x, y, l, a, 0, sx, sy)	
	end
end

function opening:update(dt)
	self:handleInput()
	
	local slot = self.slot	
	--check if we need to change the slot we're on, and if we need to end the opening
	if self.counter >= self.openRoll[slot].counter then
		if self.slot >= self.slotend then
			stateEngine:stateSwitch("menu")		
		else
			df.temp = nil
			self.slot = self.slot + 1
			local newInstance = math.random(0,1000)
			while newInstance == self.instance do
				newInstance = math.random(0,1000)
			end
			self.instance = newInstance			
		end
		self.counter = 0
	else		
		if self.openRoll.countdown then
			self.counter = self.counter + dt
		end
	end
	
	if stateEngine.state ~= "menu" then --inelegant solution. Two of the above conditions would call this update so we put it here for succinctness.
		self.openRoll[self.slot]:update(dt)
	end
end

function opening:draw()
	local slot = self.slot
	self.openRoll[slot].draw()
end

function opening:handleInput()
	if ic.confirm.isDown then --or ic.back.isDown then --don't feel like doing a delay for this
		self:skip()
	end
end

function opening:skip()
	stateEngine:stateSwitch("menu")
end

function opening:unload()
	audio:unloadProfile(self.index)
	df.temp = nil
	self.counter = 0
	self.slot = 1
	lg.setFont(defaultFont)
	lg.setColor(255,255,255,255)
end

return opening