local l = require 'engine.load'
local o = require 'engine.opening.opening'
local m = require 'engine.menu.menu'
local a = audio
local g = require 'engine.gameplay.gameplay'

stateEngine = {
		skipdraw = false,
		state = "",
		nextGame = "new",
		load = {		
			load = function()
				l:initializeRNG()
				l:initializeFonts()
				l:initializeGlobals()
				stateEngine:stateSwitch("open")
			end,
			unload = function() end,
		},
		open = {
			load = function()
				a:loadProfile(o)
				o:load()
			end,
			update = function(dt)
				o:update(dt)
			end,			
			draw = function()			
				o:draw()
			end,
			unload = function()
				o:unload()
			end,
		},
		menu = {
			load = function()
				a:loadProfile(m)
				m:load()
			end,
			update = function(dt)
				m:update(dt)
			end,
			draw = function()
				m:draw()
			end,
			unload = function()
				m:unload()
			end,
		},
		play = {
			load = function()
				g.audioSystem = a
				g:load(stateEngine.nextGame)
			end,
			update = function(dt)
				g:update(dt)
			end,
			draw = function()
				g:draw()
			end,
			unload = function()
				g:unload()
			end,
		},
		exit = {},
}

function stateEngine:stateSwitch(state, gameToLoad)
	if gameToLoad then self.nextGame = gameToLoad end
	self[self.state].unload()--pass state to switch to for g
	self.state = state
	print("Game State == "..state)
	self[self.state].load()
	self.skipdraw = true
end


return stateEngine