lg = love.graphics
lk = love.keyboard
la = love.audio
bump = require 'engine.lib.bump'
audio = require 'engine.audio'
require 'engine.interface.colors'
interface = require 'engine.interface.interface'
sEngine = require 'engine.states'
damageList = require 'engine.gameplay.damagelist'
require 'colortools'

updateNumber = 0
pauseUpdates = false

function love.load()
	--mute()
	sEngine.state = "load"
	interface:load()
	ic = interface.controls
	sEngine[sEngine.state].load()
end

function love.update(dt)
	if not pauseUpdates then
		interface:update(dt)
		audio:update(dt)
		if sEngine.skipdraw then
			sEngine.skipdraw = false
		end
		sEngine[sEngine.state].update(dt)
	end
end

function love.draw()
	if not pauseUpdates then
		if not sEngine.skipdraw then
			sEngine[sEngine.state].draw()
		end
		updateNumber = updateNumber + 1
	end
end

function findUniqueIndex(table)
	local n = 1
	while table[n] do
		n = math.random(1,1000)
	end
	return n
end

function mute()
	la.cVolume = la.getVolume()
	la.setVolume(0)
end

function unmute()
	la.setVolume(la.cVolume or 1)
end

function maxVolume()
	la.setVolume(1)
end

function getSpeedByVector(x1,y1,x2,y2)
	local xspeed = (x1-x2)/1
	local yspeed = (y1-y2)/1
	
	return xspeed, yspeed
end


function addTablesByValue(t1, t2)
--a messy function that should only be used sparingly
	local ret = {}
	for i,v in pairs(t1) do --this will only add values from t2 if they already have indices in t1
		if t2[i] then
			ret[i] = v + t2[i]
			
			print(tostring(v).." added to "..tostring(t2[i]))
		end
	end
	return ret
end

function love.keypressed(key)
	if key == "f1" then
		pauseUpdates = not pauseUpdates
	end
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function convertToTimeNotation(sec) --a number in seconds
	sec = round(sec, 2) --round to a number of seconds + .00
	local m = math.floor(sec / 60) --we have the total minutes
	local h = math.floor(m / 60) --we have the final hours
	local s = sec - (m * 60) --we have the final seconds.milli
	m = m - (h * 60) --we have the final minutes
	
	local sh, sm, ss
	
	if h < 10 then
		sh = "0"..tostring(h)
	else
		sh = tostring(h)
	end
	
	if m < 10 then
		sm = "0"..tostring(m)
	else
		sm = tostring(m)
	end
	
	if s < 10 then
		ss = "0"..tostring(s)
	else
		ss = tostring(s)
	end
	
	local s = sh..":"..sm..":"..ss
	
	return s
end
